import subprocess
import os
import signal
import time

# Actual prover call
cmd = './res/iproveropt --abstr_ref "[]" --abstr_ref_under "[]" --clausifier res/vclausify_rel --comb_inst_mult 3 --comb_mode clause_based --comb_res_mult 1 --comb_sup_deep_mult 64 --comb_sup_mult 16 --conj_cone_tolerance 3. --demod_completeness_check full --demod_use_ground true --eq_ax_congr_red true --extra_neg_conj none --inst_activity_threshold 500 --inst_dismatching true --inst_eager_unprocessed_to_passive true --inst_eq_res_simp false --inst_learning_factor 2 --inst_learning_loop_flag true --inst_learning_start 3000 --inst_lit_activity_flag true --inst_lit_sel "[+prop;+sign;+ground;-num_var;-num_symb]" --inst_lit_sel_side num_symb --inst_orphan_elimination true --inst_out_proof true --inst_passive_queue_type priority_queues --inst_passive_queues "[[-conj_dist;+conj_symb;-num_var];[+age;-num_symb]]" --inst_passive_queues_freq "[25;2]" --inst_prop_sim_given true --inst_prop_sim_new false --inst_restr_to_given false --inst_sel_renew solver --inst_solver_calls_frac 1.  --inst_solver_per_active 1400 --inst_sos_flag false --inst_start_prop_sim_after_learn 3 --inst_subs_given false --inst_subs_new false --instantiation_flag true --out_options none --pred_elim true --prep_def_merge true --prep_def_merge_mbd true --prep_def_merge_prop_impl false --prep_def_merge_tr_cl false --prep_def_merge_tr_red false --prep_gs_sim true --prep_res_sim true --prep_sem_filter exhaustive --prep_sup_sim_all true --prep_sup_sim_sup false --prep_unflatten true --prep_upred true --prolific_symb_bound 256 --prop_solver_per_cl 1024 --pure_diseq_elim true --res_backward_subs full --res_backward_subs_resolution true --res_forward_subs full --res_forward_subs_resolution true --res_lit_sel adaptive --res_lit_sel_side none --res_ordering kbo --res_out_proof true --res_passive_queue_type priority_queues --res_passive_queues "[[-conj_dist;+conj_symb;-num_symb];[+age;-num_symb]]" --res_passive_queues_freq "[15;5]" --res_prop_simpl_given true --res_prop_simpl_new false --res_sim_input true --res_time_limit 300.00 --res_to_prop_solver active --resolution_flag true --sat_out_model small --schedule none --share_sel_clauses true --smt_ac_axioms fast --smt_preprocessing true --splitting_cvd false --splitting_cvd_svl false --splitting_grd true --splitting_mode input --splitting_nvd 32 --stats_out sel --sub_typing true --subs_bck_mult 8 --sup_full_bw "[]" --sup_full_fw "[]" --sup_full_triv "[Unflattening]" --sup_fun_splitting false --sup_immed_bw_immed "[]" --sup_immed_bw_main "[]" --sup_immed_fw_immed "[]" --sup_immed_fw_main "[Subsumption;UnitSubsAndRes;Demod;DemodLoopTriv;LightNorm;DemodLightNormLoopTriv;ACJoinability]" --sup_immed_triv "[PropSubs]" --sup_indices_passive "[NonunitSubsumption;FwDemod;BwDemod]" --sup_input_bw "[]" --sup_input_fw "[Subsumption;SubsumptionRes;UnitSubsAndRes;DemodLoopTriv;LightNorm;DemodLightNormLoopTriv;ACNormalisation]" --sup_input_triv "[Unflattening]" --sup_iter_deepening 0 --sup_passive_queue_type queue --sup_passive_queues "[[-ground]]" --sup_passive_queues_freq "[10]" --sup_prop_simpl_given false --sup_prop_simpl_new true --sup_restarts_mult 2 --sup_score sim_d_gen --sup_share_max_num_cl 160 --sup_share_score_frac 0.8 --sup_smt_interval 10000 --sup_symb_ordering arity --sup_to_prop_solver active --superposition_flag true --time_out_prep_mult 0.1 --clausifier_options "--mode tclausify -t 2.999952793121338" --sub_typing false --preprocessing_flag false  --suppress_sat_res true --time_out_real 15 /home/eholden/JJTProblemFiles/JJT00632_1.p'



# Make prover call as usual, but redirect output to PIPES to avoid file-handling
print("Starting prover")
proc = subprocess.Popen(cmd, shell=True, preexec_fn=os.setsid, stdout=subprocess.PIPE, stderr=subprocess.PIPE)

print("Sleeping...")
time.sleep(1)
print("Awake!")

# Kill the process
if proc.poll() is None:
    # Get process group id and kill the group
    pgrp = os.getpgid(proc.pid)
    os.killpg(pgrp, signal.SIGKILL)
    print("Killed process: {0}".format(pgrp))


out, err = proc.communicate()  # Empty buffer

# Print error code
print("Stderr: ", err)
print("Returncode: ", proc.returncode)

